import java.util.Random;
import com.pi4j.io.i2c.I2CBus;
import com.pi4j.io.i2c.I2CDevice;
import com.pi4j.io.i2c.I2CFactory;
import com.pi4j.io.serial.Serial;
import com.pi4j.io.serial.SerialDataEvent;
import com.pi4j.io.serial.SerialDataListener;
import com.pi4j.io.serial.SerialFactory;
import com.pi4j.io.serial.SerialPortException;
import com.pi4j.io.gpio.GpioController;
import com.pi4j.io.gpio.GpioFactory;
import com.pi4j.io.gpio.GpioPinDigitalOutput;
import com.pi4j.io.gpio.GpioPinDigitalInput;
import com.pi4j.io.gpio.PinState;
import com.pi4j.io.gpio.RaspiPin;
import com.pi4j.io.gpio.PinPullResistance;
import com.pi4j.io.gpio.event.GpioPinDigitalStateChangeEvent;
import com.pi4j.io.gpio.event.GpioPinListenerDigital;

import java.util.Random;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.charset.StandardCharsets;
import java.awt.KeyEventDispatcher;
import java.awt.KeyboardFocusManager;
import java.awt.event.KeyEvent;
import java.lang.Object;
import java.util.Scanner;
import java.io.Console;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.lang.Object;
import java.io.File;
import java.io.IOException;
import java.util.Arrays;

class HexAutomation extends Thread
{
    public static void main(String args[])
    {
        (new HexAutomation()).start();
    }

    final Serial serial = SerialFactory.createInstance();

    final Object sendLock = new Object();

    final double PI = 3.1415926535897931;

    public final double CRrFemurHornOffset1 = 0;
    public final double CRmFemurHornOffset1 = 0;
    public final double CRfFemurHornOffset1 = 0;
    public final double CLrFemurHornOffset1 = 0;
    public final double CLmFemurHornOffset1 = 0;
    public final double CLfFemurHornOffset1 = 0;
    public final double CPfConst = 592; //old 650 ; 900*(1000/cPwmDiv)+cPFConst must always be 1500
    public final double CPwmDiv = 991; //old 1059;
    public final double CTravelDeadZone = 1;
    public final double C1Dec = 10;
    public final double C2Dec = 100;
    public final double C4Dec = 10000;
    public final double C6Dec = 1000000;
    public final int CLf = 5;

    public final int CLm = 4;
    public final int CLr = 3;
    public final int CRf = 2;
    public final int CRm = 1;
    public final int CRr = 0;
    public double cRRCoxaMin1 = -650; //Mechanical limits of the Right Rear Leg
    public double cRRCoxaMax1 = 650;
    public double cRRFemurMin1 = -1050;
    public double cRRFemurMax1 = 150;
    public double cRRTibiaMin1 = -450;
    public double cRRTibiaMax1 = 350;

    public double cRMCoxaMin1 = -650; //Mechanical limits of the Right Middle Leg
    public double cRMCoxaMax1 = 650;
    public double cRMFemurMin1 = -1050;
    public double cRMFemurMax1 = 150;
    public double cRMTibiaMin1 = -450;
    public double cRMTibiaMax1 = 350;

    public double cRFCoxaMin1 = -650; //Mechanical limits of the Right Front Leg
    public double cRFCoxaMax1 = 650;
    public double cRFFemurMin1 = -1050;
    public double cRFFemurMax1 = 150;
    public double cRFTibiaMin1 = -450;
    public double cRFTibiaMax1 = 350;

    public double cLRCoxaMin1 = -650; //Mechanical limits of the Left Rear Leg
    public double cLRCoxaMax1 = 650;
    public double cLRFemurMin1 = -1050;
    public double cLRFemurMax1 = 150;
    public double cLRTibiaMin1 = -450;
    public double cLRTibiaMax1 = 350;

    public double cLMCoxaMin1 = -650; //Mechanical limits of the Left Middle Leg
    public double cLMCoxaMax1 = 650;
    public double cLMFemurMin1 = -1050;
    public double cLMFemurMax1 = 150;
    public double cLMTibiaMin1 = -450;
    public double cLMTibiaMax1 = 350;

    public double cLFCoxaMin1 = -650; //Mechanical limits of the Left Front Leg
    public double cLFCoxaMax1 = 650;
    public double cLFFemurMin1 = -1050;
    public double cLFFemurMax1 = 150;
    public double cLFTibiaMin1 = -450;
    public double cLFTibiaMax1 = 350;

    public double cRRCoxaAngle1 = -450;
    public double cRMCoxaAngle1 = 0;
    public double cRFCoxaAngle1 = 450;
    public double cLRCoxaAngle1 = -450;
    public double cLMCoxaAngle1 = 0;
    public double cLFCoxaAngle1 = 450;

    public double cRFOffsetX = -70;
    public double cRFOffsetZ = -120;

    public double cLFOffsetZ = -120;
    public double cLFOffsetX = 70;

    public double cRROffsetZ = 120;
    public double cRROffsetX = -70;

    public double cLROffsetZ = 120;
    public double cLROffsetX = 70;

    public double cRMOffsetX = -140;
    public double cRMOffsetZ = 0;

    public double cLMOffsetX = 140;
    public double cLMOffsetZ = 0;

    public double CoxaLength = 30;
    public double FemurLength = 60;
    public double TibiaLength = 65;

    public double cRRCoxaLength = CoxaLength;
    public double cRMCoxaLength = CoxaLength;
    public double cRFCoxaLength = CoxaLength;
    public double cLRCoxaLength = CoxaLength;
    public double cLMCoxaLength = CoxaLength;
    public double cLFCoxaLength = CoxaLength;
    public double cRRFemurLength = FemurLength;
    public double cRMFemurLength = FemurLength;
    public double cRFFemurLength = FemurLength;
    public double cLRFemurLength = FemurLength;
    public double cLMFemurLength = FemurLength;
    public double cLFFemurLength = FemurLength;
    public double cLFTibiaLength = TibiaLength;
    public double cLMTibiaLength = TibiaLength;
    public double cLRTibiaLength = TibiaLength;
    public double cRFTibiaLength = TibiaLength;
    public double cRMTibiaLength = TibiaLength;
    public double cRRTibiaLength = TibiaLength;

    public final double CHexInitXz = 105;
    public final double CHexInitXzCos45 = 74; // COS(45) = .7071
    public final double CHexInitXzSin45 = 74; // sin(45) = .7071
    public final double CHexInitY = 26;

    public double CRfInitPosX = CHexInitXzCos45;
    public double CRfInitPosY = CHexInitY;
    public double CRfInitPosZ = -CHexInitXzSin45;

    public double CLrInitPosX = CHexInitXzCos45;
    public double CLrInitPosY = CHexInitY;
    public double CLrInitPosZ = CHexInitXzCos45;

    public double CLmInitPosX = CHexInitXz;
    public double CLmInitPosY = CHexInitY;
    public double CLmInitPosZ = 0;

    public double CLfInitPosX = CHexInitXzCos45;
    public double CLfInitPosY = CHexInitY;
    public double CLfInitPosZ = -CHexInitXzSin45;

    public double CRmInitPosX = CHexInitXz;
    public double CRmInitPosY = CHexInitY;
    public double CRmInitPosZ = 0;

    public double CRrInitPosX = CHexInitXzCos45;
    public double CRrInitPosY = CHexInitY;
    public double CRrInitPosZ = CHexInitXzSin45;

    public double TravelLengthY;

    public double _cCoxaAngle1[] =
            {
                    cRRCoxaAngle1, cRMCoxaAngle1, cRFCoxaAngle1, cLRCoxaAngle1, cLMCoxaAngle1, cLFCoxaAngle1
            };

    //Leg Lengths
    public double _cCoxaLength[] =
            {
                    cRRCoxaLength, cRMCoxaLength, cRFCoxaLength, cLRCoxaLength, cLMCoxaLength, cLFCoxaLength
            };

    public double _cCoxaMax1[] =
            {
                    cRRCoxaMax1, cRMCoxaMax1, cRFCoxaMax1, cLRCoxaMax1, cLMCoxaMax1, cLFCoxaMax1
            };

    public double _cCoxaMin1[] =
            {
                    cRRCoxaMin1, cRMCoxaMin1, cRFCoxaMin1, cLRCoxaMin1, cLMCoxaMin1, cLFCoxaMin1
            };

    public double _cFemurHornOffset1[] =
            {
                    CRrFemurHornOffset1, CRmFemurHornOffset1, CRfFemurHornOffset1, CLrFemurHornOffset1, CLmFemurHornOffset1, CLfFemurHornOffset1
            };

    public double _cFemurLength[] =
            {
                    cRRFemurLength, cRMFemurLength, cRFFemurLength, cLRFemurLength, cLMFemurLength, cLFFemurLength
            };

    public double _cFemurMax1[] =
            {
                    cRRFemurMax1, cRMFemurMax1, cRFFemurMax1, cLRFemurMax1, cLMFemurMax1, cLFFemurMax1
            };

    public double _cFemurMin1[] =
            {
                    cRRFemurMin1, cRMFemurMin1, cRFFemurMin1, cLRFemurMin1, cLMFemurMin1, cLFFemurMin1
            };

    //Start positions for the leg
    public double _cInitPosX[] = {CRrInitPosX, CRmInitPosX, CRfInitPosX, CLrInitPosX, CLmInitPosX, CLfInitPosX};
    public double _cInitPosY[] = {CRrInitPosY, CRmInitPosY, CRfInitPosY, CLrInitPosY, CLmInitPosY, CLfInitPosY};
    public double _cInitPosZ[] = {CRrInitPosZ, CRmInitPosZ, CRfInitPosZ, CLrInitPosZ, CLmInitPosZ, CLfInitPosZ};

    public double _cOffsetX[] = {cRROffsetX, cRMOffsetX, cRFOffsetX, cLROffsetX, cLMOffsetX, cLFOffsetX};
    public double _cOffsetZ[] = {cRROffsetZ, cRMOffsetZ, cRFOffsetZ, cLROffsetZ, cLMOffsetZ, cLFOffsetZ};

    public double _coxaAngle1[] = {0,0,0,0,0,0};

    public double _cTibiaLength[] =
            {
                    cRRTibiaLength, cRMTibiaLength, cRFTibiaLength, cLRTibiaLength, cLMTibiaLength, cLFTibiaLength
            };

    public double _cTibiaMax1[] =
            {
                    cRRTibiaMax1, cRMTibiaMax1, cRFTibiaMax1, cLRTibiaMax1, cLMTibiaMax1, cLFTibiaMax1
            };

    public double _cTibiaMin1[] =
            {
                    cRRTibiaMin1, cRMTibiaMin1, cRFTibiaMin1, cLRTibiaMin1, cLMTibiaMin1, cLFTibiaMin1
            };

    public double _femurAngle1[] = new double[6]; //Actual Angle of the vertical hip, decimals = 1
    public int _gaitLegNr[] = {0, 0, 0, 0 ,0, 0}; //Init position of the leg
    public double _gaitPosX[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative X position corresponding to the Gait
    public double _gaitPosY[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative Y position corresponding to the Gait
    public double _gaitPosZ[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative Z position corresponding to the Gait
    public double _gaitRotY[] = {0, 0, 0, 0 ,0, 0}; //Array containing Relative Y rotation corresponding to the Gait

    //ArcCosinus Table
    //Table build in to 3 part to get higher accuracy near cos = 1.
    //The biggest error is near cos = 1 and has a biggest value of 3*0.012098rad = 0.521 deg.
    //-    Cos 0 to 0.9 is done by steps of 0.0079 rad. [1/127]
    //-    Cos 0.9 to 0.99 is done by steps of 0.0008 rad [0.1/127]
    //-    Cos 0.99 to 1 is done by step of 0.0002 rad [0.01/64]
    //Since the tables are overlapping the full range of 127+127+64 is not necessary. Total bytes: 277
    public final double _getACos[] =
            {
                    255, 254, 252, 251, 250, 249, 247, 246, 245, 243, 242, 241, 240, 238, 237, 236, 234, 233, 232, 231, 229, 228, 227, 225,
                    224, 223, 221, 220, 219, 217, 216, 215, 214, 212, 211, 210, 208, 207, 206, 204, 203, 201, 200, 199, 197, 196, 195, 193,
                    192, 190, 189, 188, 186, 185, 183, 182, 181, 179, 178, 176, 175, 173, 172, 170, 169, 167, 166, 164, 163, 161, 160, 158,
                    157, 155, 154, 152, 150, 149, 147, 146, 144, 142, 141, 139, 137, 135, 134, 132, 130, 128, 127, 125, 123, 121, 119, 117,
                    115, 113, 111, 109, 107, 105, 103, 101, 98, 96, 94, 92, 89, 87, 84, 81, 79, 76, 73, 73, 73, 72, 72, 72, 71, 71, 71, 70, 70,
                    70, 70, 69, 69, 69, 68, 68, 68, 67, 67, 67, 66, 66, 66, 65, 65, 65, 64, 64, 64, 63, 63, 63, 62, 62, 62, 61, 61, 61, 60, 60, 59,
                    59, 59, 58, 58, 58, 57, 57, 57, 56, 56, 55, 55, 55, 54, 54, 53, 53, 53, 52, 52, 51, 51, 51, 50, 50, 49, 49, 48, 48, 47, 47, 47,
                    46, 46, 45, 45, 44, 44, 43, 43, 42, 42, 41, 41, 40, 40, 39, 39, 38, 37, 37, 36, 36, 35, 34, 34, 33, 33, 32, 31, 31, 30, 29, 28,
                    28, 27, 26, 25, 24, 23, 23, 23, 23, 22, 22, 22, 22, 21, 21, 21, 21, 20, 20, 20, 19, 19, 19, 19, 18, 18, 18, 17, 17, 17, 17, 16,
                    16, 16, 15, 15, 15, 14, 14, 13, 13, 13, 12, 12, 11, 11, 10, 10, 9, 9, 8, 7, 6, 6, 5, 3, 0
            };

    public double _legPosX[] = {0, 0, 0, 0 ,0, 0}; //Actual X Position of the Leg should be length of 6
    public double _legPosY[] = {0, 0, 0, 0 ,0, 0}; //Actual Y Position of the Leg
    public double _legPosZ[] = {0, 0, 0, 0 ,0, 0}; //Actual Z Position of the Leg
    public double _tibiaAngle1[] = {0, 0, 0, 0 ,0, 0}; //Actual Angle of the knee, decimals = 1

    public double BalanceMode;

    public double _bodyFkPosX; //Output Position X of feet with Rotation
    public double _bodyFkPosY; //Output Position Y of feet with Rotation
    public double _bodyFkPosZ; //Output Position Z of feet with Rotation
    public double BodyPosX; //Global Input for the position of the body
    public double BodyPosY;
    public double BodyPosZ;
    public double BodyRotOffsetX; //Input X offset value to adjust center pofloat of rotation
    public double BodyRotOffsetY; //Input Y offset value to adjust center pofloat of rotation
    public double BodyRotOffsetZ; //Input Z offset value to adjust center pofloat of rotation
    public double BodyRotX1; //Global Input pitch of the body
    public double BodyRotY1; //Global Input rotation of the body
    public double BodyRotZ1; //Global Input roll of the body
    //public double _cos4; //Output Cosinus of the given Angle, decimals = 4
    public double _cycleTime; //Total Cycle time
    public boolean _fContinueWalking; // should we continue to walk?
    public boolean _fSlHold; //Single leg control mode
    public boolean _fWalking; //  True if the robot are walking
    public double _gaitStep;
    public int GaitType;
    public double _halfLiftHeigth; //If TRUE the outer positions of the lifted legs will be half height
    public double _ikSolution; //Output true if the solution is possible
    public double _ikSolutionError; //Output true if the solution is NOT possible
    public double _ikSolutionWarning; //Output true if the solution is NEARLY possible
    //[TIMING]
    public int _lastLeg; //TRUE when the current leg is the last leg of the sequence
    public int _legIndex; //Index used for leg Index Number
    public int LegLiftHeight; //Current Travel height
    public int _liftDivFactor; //Normally: 2, when NrLiftedPos=5: 4
    public int _nomGaitSpeed; //Nominal speed of the gait
    public int _nrLiftedPos; //Number of positions that a single leg is lifted [1-3]
    public int _prevSelectedLeg;
    public int _selectedLeg;
    //public double _sin4; //Output Sinus of the given Angle, decimals = 4
    public int _stepsInGait; //Number of steps in gait
    public double _tlDivFactor; //Number of steps that a leg is on the floor while walking

    public double _totalTransX;
    public double _totalTransY;
    public double _totalTransZ;
    public double _totalXBal1;
    public double _totalYBal1;
    public double _totalZBal1;

    public double TravelLengthX; //Current Travel length X
    public double TravelLengthZ; //Current Travel length Z
    public Boolean _travelRequest; //Temp to check if the gait is in motion
    public double TravelRotationY; //Current Travel Rotation Y

    public double _xYhyp2; //Output presenting Hypotenuse of X and Y


    public double BalanceDivFactor = 6;

    public void Send(String toSend)
    {
        synchronized (sendLock)
        {
            serial.writeln(toSend);
        }
    }

    public void ResetServos()
    {
        for (int i = 0; i < 32; i++)
        {
            Send("#" + i +"P0S700");
        }
    }

    public void run()
    {
		Thread.currentThread().setPriority(Thread.MAX_PRIORITY);

        serial.open("//dev//ttyAMA0", 38400);

		serial.addListener(new SerialDataListener() {
            @Override
            public void dataReceived(SerialDataEvent event) 
			{
				try
				{
					int s = event.getData().indexOf('~') + 1;
					int e = event.getData().indexOf('!') - 1;

					if (e < s || event.getData().length() < 8)
						return;

					String r = event.getData().substring(s,e);
				
					System.out.println(r);
				
				    GaitType = Integer.parseInt(r.split("\\|")[0]);

            		TravelLengthZ = Integer.parseInt(r.split("\\|")[1]);
            		TravelLengthX = Integer.parseInt(r.split("\\|")[2]);
            		TravelRotationY = Integer.parseInt(r.split("\\|")[3]);
				}
				catch (Exception exc)
				{
				}
            }            
        });
  
        ResetServos();

        byte[] buffer = new byte[16];
        float count = 0;
        String rawData = "";
        float Disabled = 0;

        LegLiftHeight = 20;
        BodyPosY = 35;

        Disabled = 0;

        GaitType = 1;

        BalanceMode = 0;

		GaitSelect();

        for (_legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            _legPosX[_legIndex] = (_cInitPosX[_legIndex]); //Set start positions for each leg
            _legPosY[_legIndex] = (_cInitPosY[_legIndex]);
            _legPosZ[_legIndex] = (_cInitPosZ[_legIndex]);
        }

        while (true)
        {
            if (Disabled == 1)
            {
                ResetServos();
                continue;
            }

            //Gait
            GaitSeq();

            //Balance calculations
            _totalTransX = 0; //reset values used for calculation of balance
            _totalTransZ = 0;
            _totalTransY = 0;
            _totalXBal1 = 0;
            _totalYBal1 = 0;
            _totalZBal1 = 0;

            _ikSolution = 0;
            _ikSolutionError = 0;
            _ikSolutionWarning = 0;
			
            //Do IK for all Right legs
            for (_legIndex = 0; _legIndex <= 2; _legIndex++)
            {
                BodyFk(-_legPosX[_legIndex] + BodyPosX + _gaitPosX[_legIndex] - _totalTransX,
                        _legPosZ[_legIndex] + BodyPosZ + _gaitPosZ[_legIndex] - _totalTransZ,
                        _legPosY[_legIndex] + BodyPosY + _gaitPosY[_legIndex] - _totalTransY,
                        _gaitRotY[_legIndex], _legIndex);

                LegIK(_legPosX[_legIndex] - BodyPosX + _bodyFkPosX - (_gaitPosX[_legIndex] - _totalTransX),
                        _legPosY[_legIndex] + BodyPosY - _bodyFkPosY + _gaitPosY[_legIndex] - _totalTransY,
                        _legPosZ[_legIndex] + BodyPosZ - _bodyFkPosZ + _gaitPosZ[_legIndex] - _totalTransZ,
                        _legIndex);
            }

            //Do IK for all Left legs
            for (_legIndex = 3; _legIndex <= 5; _legIndex++)
            {
                BodyFk(_legPosX[_legIndex] - BodyPosX + _gaitPosX[_legIndex] - _totalTransX,
                        _legPosZ[_legIndex] + BodyPosZ + _gaitPosZ[_legIndex] - _totalTransZ,
                        _legPosY[_legIndex] + BodyPosY + _gaitPosY[_legIndex] - _totalTransY,
                        _gaitRotY[_legIndex], _legIndex);
                LegIK(_legPosX[_legIndex] + BodyPosX - _bodyFkPosX + _gaitPosX[_legIndex] - _totalTransX,
                        _legPosY[_legIndex] + BodyPosY - _bodyFkPosY + _gaitPosY[_legIndex] - _totalTransY,
                        _legPosZ[_legIndex] + BodyPosZ - _bodyFkPosZ + _gaitPosZ[_legIndex] - _totalTransZ,
                        _legIndex);
            }

            //System.out.println("IKSolution " + _ikSolution);
            //System.out.println("IKSolutionWarning " + _ikSolutionWarning);
            //System.out.println("IKSolutionError " + _ikSolutionError);
            //System.out.println("-----------");

            if (_ikSolutionError == 1 || _ikSolution == 0)
            {
                //System.out.println("No solution found ----------------------------------------------");
                continue;
            }

            CheckAngles();

            try
            {
                Thread.sleep(_nomGaitSpeed);
            }
            catch (InterruptedException e)
            {
            }

            UpdateServoDriver();
        }
    }

    private void BodyFk(double posX, double posZ, double posY, double RotationY, int BodyIKLeg)
    {
        double sinA4; //Sin buffer for BodyRotX calculations
        double cosA4; //Cos buffer for BodyRotX calculations
        double sinB4; //Sin buffer for BodyRotX calculations
        double cosB4; //Cos buffer for BodyRotX calculations
        double sinG4; //Sin buffer for BodyRotZ calculations
        double cosG4; //Cos buffer for BodyRotZ calculations

        //Calculating totals from center of the body to the feet
        double cprX = (_cOffsetX[BodyIKLeg]) + posX + BodyRotOffsetX;
        double cprY = posY + BodyRotOffsetY;
        double cprZ = (_cOffsetZ[BodyIKLeg]) + posZ + BodyRotOffsetZ;

        //Successive global rotation matrix:
        //Math shorts for rotation: Alfa [A] = Xrotate, Beta [B] = Zrotate, Gamma [G] = Yrotate
        //Sinus Alfa = SinA, cosinus Alfa = cosA. and so on...

        //First calculate sinus and cosinus for each rotation:
        double g4[] = GetSinCos(BodyRotX1 + _totalXBal1);
        sinG4 = g4[0];
        cosG4 = g4[1];

        double b4[] = GetSinCos(BodyRotZ1 + _totalZBal1);
        sinB4 = b4[0];
        cosB4 = b4[1];

        double a4[] = GetSinCos(BodyRotY1 + (RotationY * C1Dec) + _totalYBal1);
        sinA4 = a4[0];
        cosA4 = a4[1];

        //Calculation of rotation matrix:
        _bodyFkPosX = (cprX*C2Dec - ((cprX*C2Dec*cosA4/C4Dec*cosB4/C4Dec) - (cprZ*C2Dec*cosB4/C4Dec*sinA4/C4Dec) + (cprY*C2Dec*sinB4/C4Dec)))/C2Dec;
        _bodyFkPosZ = (cprZ*C2Dec - ((cprX*C2Dec*cosG4/C4Dec*sinA4/C4Dec) + (cprX*C2Dec*cosA4/C4Dec*sinB4/C4Dec*sinG4/C4Dec) + (cprZ*C2Dec*cosA4/C4Dec*cosG4/C4Dec) - (cprZ*C2Dec*sinA4/C4Dec*sinB4/C4Dec*sinG4/C4Dec) - (cprY*C2Dec*cosB4/C4Dec*sinG4/C4Dec)))/C2Dec;
        _bodyFkPosY = (cprY*C2Dec - ((cprX*C2Dec*sinA4/C4Dec*sinG4/C4Dec) - (cprX*C2Dec*cosA4/C4Dec*cosG4/C4Dec*sinB4/C4Dec) + (cprZ*C2Dec*cosA4/C4Dec*sinG4/C4Dec) + (cprZ*C2Dec*cosG4/C4Dec*sinA4/C4Dec*sinB4/C4Dec) + (cprY*C2Dec*cosB4/C4Dec*cosG4/C4Dec)))/C2Dec;
    }

    private void LegIK(double IKFeetPosX, double IKFeetPosY, double IKFeetPosZ, int LegIKLegNr)
    {
        double IKSW2; //Length between Shoulder and Wrist, decimals = 2
        double IKA14; //Angle of the line S>W with respect to the ground in radians, decimals = 4
        double IKA24; //Angle of the line S>W with respect to the femur in radians, decimals = 4
        double IKFeetPosXZ; //Diagonal direction from Input X and Z

        double Temp1;
        double Temp2;
        double T3;

        //Calculate IKCoxaAngle and IKFeetPosXZ
        //float getatan = GetATan2(IKFeetPosX, IKFeetPosZ);
        _coxaAngle1[LegIKLegNr] = ((GetATan2(IKFeetPosX, IKFeetPosZ) * 180) / 3141) + (_cCoxaAngle1[LegIKLegNr]);

        //Length between the Coxa and tars [foot]
        IKFeetPosXZ = _xYhyp2/C2Dec;

        //Using GetAtan2 for solving IKA1 and IKSW
        //IKA14 - Angle between SW line and the ground in radians
        //IKA14 = GetATan2(IKFeetPosY - TarsOffsetY, IKFeetPosXZ - (cCoxaLength[LegIKLegNr]) - TarsOffsetXZ);
        IKA14 = GetATan2(IKFeetPosY, IKFeetPosXZ - (_cCoxaLength[LegIKLegNr]));

        //IKSW2 - Length between femur axis and tars
        IKSW2 = _xYhyp2;

        //IKA2 - Angle of the line S>W with respect to the femur in radians
        Temp1 = ((((double)(_cFemurLength[LegIKLegNr])*(_cFemurLength[LegIKLegNr])) -
                ((double)(_cTibiaLength[LegIKLegNr])*(_cTibiaLength[LegIKLegNr])))*C4Dec + (IKSW2*IKSW2));
        Temp2 = 2*(_cFemurLength[LegIKLegNr])*C2Dec*IKSW2;
        T3 = Temp1/(Temp2/C4Dec);
        IKA24 = GetArcCos(T3);
        //IKFemurAngle
        _femurAngle1[LegIKLegNr] = -(IKA14 + IKA24)*180/3141 + 900 + _cFemurHornOffset1[LegIKLegNr];

        //IKTibiaAngle
        Temp1 = ((((double)(_cFemurLength[LegIKLegNr])*(_cFemurLength[LegIKLegNr])) +
                ((double)(_cTibiaLength[LegIKLegNr])*(_cTibiaLength[LegIKLegNr])))*C4Dec - (IKSW2*IKSW2));
        Temp2 = (2*(_cFemurLength[LegIKLegNr])*(_cTibiaLength[LegIKLegNr]));

        _tibiaAngle1[LegIKLegNr] = -(900 - GetArcCos(Temp1 / Temp2) * 180 / 3141);

        //Set the Solution quality
        if (IKSW2 < ((_cFemurLength[LegIKLegNr]) + (_cTibiaLength[LegIKLegNr]) - 30)*C2Dec)
            _ikSolution = 1;
        else
        {
            if (IKSW2 < ((_cFemurLength[LegIKLegNr]) + (_cTibiaLength[LegIKLegNr]))*C2Dec)
                _ikSolutionWarning = 1;
            else
                _ikSolutionError = 1;
        }


    }

    public void GaitSelect()
    {
        //Gait selector
        switch (GaitType)
        {
            case 0:
                //Ripple Gait 12 steps
                _gaitLegNr[CLr] = 1;
                _gaitLegNr[CRf] = 3;
                _gaitLegNr[CLm] = 5;
                _gaitLegNr[CRr] = 7;
                _gaitLegNr[CLf] = 9;
                _gaitLegNr[CRm] = 11;

                _nrLiftedPos = 3;
                _halfLiftHeigth = 3;
                _tlDivFactor = 8;
                _stepsInGait = 12;
                _nomGaitSpeed = 70;
                break;
            case 1:
                //Tripod 8 steps
                _gaitLegNr[CLr] = 5;
                _gaitLegNr[CRf] = 1;
                _gaitLegNr[CLm] = 1;
                _gaitLegNr[CRr] = 1;
                _gaitLegNr[CLf] = 5;
                _gaitLegNr[CRm] = 5;

                _nrLiftedPos = 3;
                _halfLiftHeigth = 3;
                _tlDivFactor = 4;
                _stepsInGait = 8;
                _nomGaitSpeed = 155;
                break;
            case 2:
                //Triple Tripod 12 step
                _gaitLegNr[CRf] = 3;
                _gaitLegNr[CLm] = 4;
                _gaitLegNr[CRr] = 5;
                _gaitLegNr[CLf] = 9;
                _gaitLegNr[CRm] = 10;
                _gaitLegNr[CLr] = 11;

                _nrLiftedPos = 3;
                _halfLiftHeigth = 3;
                _tlDivFactor = 8;
                _stepsInGait = 12;
                _nomGaitSpeed = 60;
                break;
            case 3:
                // Triple Tripod 16 steps, use 5 lifted positions
                _gaitLegNr[CRf] = 4;
                _gaitLegNr[CLm] = 5;
                _gaitLegNr[CRr] = 6;
                _gaitLegNr[CLf] = 12;
                _gaitLegNr[CRm] = 13;
                _gaitLegNr[CLr] = 14;

                _nrLiftedPos = 5;
                _halfLiftHeigth = 1;
                _tlDivFactor = 10;
                _stepsInGait = 16;
                _nomGaitSpeed = 60;
                break;
            case 4:
                //Wave 24 steps
                _gaitLegNr[CLr] = 1;
                _gaitLegNr[CRf] = 21;
                _gaitLegNr[CLm] = 5;

                _gaitLegNr[CRr] = 13;
                _gaitLegNr[CLf] = 9;
                _gaitLegNr[CRm] = 17;

                _nrLiftedPos = 3;
                _halfLiftHeigth = 3;
                _tlDivFactor = 20;
                _stepsInGait = 24;
                _nomGaitSpeed = 70;
                break;
        }
    }

    private void GaitSeq()
    {
        //Check if the Gait is in motion
        _travelRequest = ((Math.abs(TravelLengthX) > CTravelDeadZone) || (Math.abs(TravelLengthZ) > CTravelDeadZone) || (Math.abs(TravelRotationY) > CTravelDeadZone));

        if (_nrLiftedPos == 5)
            _liftDivFactor = 4;
        else
            _liftDivFactor = 2;

        //Calculate Gait sequence
        _lastLeg = 0;
        for (_legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            // for all legs
            if (_legIndex == 5) // last leg
                _lastLeg = 1;

            Gait(_legIndex);
        } // next leg
    }

    private void Gait(int GaitCurrentLegNr)
    {
        //Clear values under the cTravelDeadZone
        if (!_travelRequest)
        {
            TravelLengthX = 0;
            TravelLengthZ = 0;
            TravelRotationY = 0;
        }
        //Leg middle up position
        //Gait in motion
        //Gait NOT in motion, return to home position
        if ((_travelRequest && (_nrLiftedPos == 1 || _nrLiftedPos == 3 || _nrLiftedPos == 5) && _gaitStep == _gaitLegNr[GaitCurrentLegNr]) || (!_travelRequest && _gaitStep == _gaitLegNr[GaitCurrentLegNr] && ((Math.abs(_gaitPosX[GaitCurrentLegNr]) > 2) ||(Math.abs(_gaitPosZ[GaitCurrentLegNr]) > 2) || (Math.abs(_gaitRotY[GaitCurrentLegNr]) > 2))))
        {
            //Up
            _gaitPosX[GaitCurrentLegNr] = 0;
            _gaitPosY[GaitCurrentLegNr] = -LegLiftHeight;
            _gaitPosZ[GaitCurrentLegNr] = 0;
            _gaitRotY[GaitCurrentLegNr] = 0;
        }
        //Optional Half heigth Rear (2, 3, 5 lifted positions)
        else if (((_nrLiftedPos == 2 && _gaitStep == _gaitLegNr[GaitCurrentLegNr]) || (_nrLiftedPos >= 3 && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] - 1 || _gaitStep == _gaitLegNr[GaitCurrentLegNr] + (_stepsInGait - 1)))) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = -TravelLengthX/_liftDivFactor;
            _gaitPosY[GaitCurrentLegNr] = -3*LegLiftHeight/(3 + _halfLiftHeigth);
            //Easier to shift between div factor: /1 (3/3), /2 (3/6) and 3/4
            _gaitPosZ[GaitCurrentLegNr] = -TravelLengthZ/_liftDivFactor;
            _gaitRotY[GaitCurrentLegNr] = -TravelRotationY/_liftDivFactor;
        }

        // Optional Half heigth front (2, 3, 5 lifted positions)
        else if ((_nrLiftedPos >= 2) && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] + 1 || _gaitStep == _gaitLegNr[GaitCurrentLegNr] - (_stepsInGait - 1)) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = TravelLengthX/_liftDivFactor;
            _gaitPosY[GaitCurrentLegNr] = -3*LegLiftHeight/(3 + _halfLiftHeigth);
            // Easier to shift between div factor: /1 (3/3), /2 (3/6) and 3/4
            _gaitPosZ[GaitCurrentLegNr] = TravelLengthZ/_liftDivFactor;
            _gaitRotY[GaitCurrentLegNr] = TravelRotationY/_liftDivFactor;
        }

        //Optional Half heigth Rear 5 LiftedPos (5 lifted positions)
        else if (((_nrLiftedPos == 5 && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] - 2))) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = -TravelLengthX/2;
            _gaitPosY[GaitCurrentLegNr] = -LegLiftHeight/2;
            _gaitPosZ[GaitCurrentLegNr] = -TravelLengthZ/2;
            _gaitRotY[GaitCurrentLegNr] = -TravelRotationY/2;
        }

        //Optional Half heigth Front 5 LiftedPos (5 lifted positions)
        else if ((_nrLiftedPos == 5) && (_gaitStep == _gaitLegNr[GaitCurrentLegNr] + 2 || _gaitStep == _gaitLegNr[GaitCurrentLegNr] - (_stepsInGait - 2)) && _travelRequest)
        {
            _gaitPosX[GaitCurrentLegNr] = TravelLengthX/2;
            _gaitPosY[GaitCurrentLegNr] = -LegLiftHeight/2;
            _gaitPosZ[GaitCurrentLegNr] = TravelLengthZ/2;
            _gaitRotY[GaitCurrentLegNr] = TravelRotationY/2;
        }

        //Leg front down position
        else if ((_gaitStep == _gaitLegNr[GaitCurrentLegNr] + _nrLiftedPos || _gaitStep == _gaitLegNr[GaitCurrentLegNr] - (_stepsInGait - _nrLiftedPos)) && _gaitPosY[GaitCurrentLegNr] < 0)
        {
            _gaitPosX[GaitCurrentLegNr] = TravelLengthX/2;
            _gaitPosZ[GaitCurrentLegNr] = TravelLengthZ/2;
            _gaitRotY[GaitCurrentLegNr] = TravelRotationY/2;
            _gaitPosY[GaitCurrentLegNr] = 0;
            //Only move leg down at once if terrain adaption is turned off
        }

        //Move body forward
        else
        {
            _gaitPosX[GaitCurrentLegNr] = _gaitPosX[GaitCurrentLegNr] - (TravelLengthX/_tlDivFactor);
            _gaitPosY[GaitCurrentLegNr] = 0;
            _gaitPosZ[GaitCurrentLegNr] = _gaitPosZ[GaitCurrentLegNr] - (TravelLengthZ/_tlDivFactor);
            _gaitRotY[GaitCurrentLegNr] = _gaitRotY[GaitCurrentLegNr] - (TravelRotationY/_tlDivFactor);
        }

        //Advance to the next step
        if (_lastLeg == 1)
        {
            //The last leg in this step
            _gaitStep = _gaitStep + 1;
            if (_gaitStep > _stepsInGait)
                _gaitStep = 1;
        }
    }

    private void BalCalcOneLeg(double PosX, double PosZ, double PosY, int BalLegNr)
    {
        //Calculating totals from center of the body to the feet
        double cprZ = (_cOffsetZ[BalLegNr]) + PosZ;
        double cprX = (_cOffsetX[BalLegNr]) + PosX;
        double cprY = 150 + PosY;

        _totalTransY += PosY;
        _totalTransZ += cprZ;
        _totalTransX += cprX;

        double lAtan = GetATan2(cprX, cprZ);
        _totalYBal1 += (lAtan*1800)/31415;

        lAtan = GetATan2(cprX, cprY);
        _totalZBal1 += ((lAtan*1800)/31415) - 900; //Rotate balance circle 90 deg

        lAtan = GetATan2(cprZ, cprY);
        _totalXBal1 += ((lAtan*1800)/31415) - 900; //Rotate balance circle 90 deg
    }

    private void BalanceBody()
    {
        _totalTransZ = _totalTransZ/BalanceDivFactor;
        _totalTransX = _totalTransX/BalanceDivFactor;
        _totalTransY = _totalTransY/BalanceDivFactor;

        if (_totalYBal1 > 0) //Rotate balance circle by +/- 180 deg
            _totalYBal1 -= 1800;
        else
            _totalYBal1 += 1800;

        if (_totalZBal1 < -1800) //Compensate for extreme balance positions that causes owerflow
            _totalZBal1 += 3600;

        if (_totalXBal1 < -1800) //Compensate for extreme balance positions that causes owerflow
            _totalXBal1 += 3600;

        //Balance rotation
        _totalYBal1 = -_totalYBal1/BalanceDivFactor;
        _totalXBal1 = -_totalXBal1/BalanceDivFactor;
        _totalZBal1 = _totalZBal1/BalanceDivFactor;
    }

    private double[] GetSinCos(double angleDeg1)
    {
        double r[] = new double[2];

        double sin = 0.0;
        double cos = 0.0;

        double angle = PI * angleDeg1 / 180.0;

        sin = Math.round(Math.sin(angle) * 10000);
        cos = Math.round(Math.cos(angle) * 10000);

        r[0] = sin;
        r[1] = cos;

        return r;
    }

    private double GetArcCos(double cos4)
    {
        boolean negativeValue /*:1*/; //If the the value is Negative

        double angleRad4 = 0;
        //Check for negative value
        if (cos4 < 0)
        {
            cos4 = -cos4;
            negativeValue = true;
        }
        else
            negativeValue = false;

        //Limit cos4 to his maximal value
        cos4 = Math.min(cos4, C4Dec);

        if ((cos4 >= 0) && (cos4 < 9000))
        {
            angleRad4 = (_getACos[(int)(cos4/79)]);
            angleRad4 = (angleRad4*616)/C1Dec; //616=acos resolution (pi/2/255) ;
        }
        else if ((cos4 >= 9000) && (cos4 < 9900))
        {
            angleRad4 = (_getACos[(int)((cos4 - 9000)/8 + 114)]);
            angleRad4 = angleRad4*616/C1Dec; //616=acos resolution (pi/2/255)
        }
        else if ((cos4 >= 9900) && (cos4 <= 10000))
        {
            angleRad4 = (_getACos[(int)((cos4 - 9900)/2 + 227)]);
            angleRad4 = angleRad4*616/C1Dec; //616=acos resolution (pi/2/255)
        }

        //Add negative sign
        if (negativeValue)
            angleRad4 = 31416 - angleRad4;

        return angleRad4;
    }

    private double GetATan2(double atanX, double atanY)
    {
        double atan4;


        _xYhyp2 = Math.sqrt((atanX * atanX * C4Dec) + (atanY * atanY * C4Dec)); //FIXED

        double angleRad4 = GetArcCos((atanX * C6Dec) / _xYhyp2);

        if (atanY < 0) // removed overhead... Atan4 = AngleRad4 * (AtanY/abs(AtanY));
            atan4 = -angleRad4;
        else
            atan4 = angleRad4;

        return atan4;
    }

    private void CheckAngles()
    {
        for (_legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            _coxaAngle1[_legIndex] = Math.min(Math.max(_coxaAngle1[_legIndex], (_cCoxaMin1[_legIndex])), (_cCoxaMax1[_legIndex]));
            _femurAngle1[_legIndex] = Math.min(Math.max(_femurAngle1[_legIndex], (_cFemurMin1[_legIndex])), (_cFemurMax1[_legIndex]));
            _tibiaAngle1[_legIndex] = Math.min(Math.max(_tibiaAngle1[_legIndex], (_cTibiaMin1[_legIndex])), (_cTibiaMax1[_legIndex]));
        }
    }

    private void UpdateServoDriver()
    {
        String sscString = "";

        int _wCoxaSscv;
        int _wFemurSscv;
        int _wTibiaSscv;

        for (_legIndex = 0; _legIndex <= 5; _legIndex++)
        {
            if (_legIndex < 3)
            {
                _wCoxaSscv = (int)Math.round(((-_coxaAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst));
                _wFemurSscv = (int)Math.round(((-_femurAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst));
                _wTibiaSscv = (int)Math.round(((-_tibiaAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst)); //120 to deal with some oddness in alignment

                if (_legIndex == 0)
                {
                    sscString += "#7P" + _wCoxaSscv;
                    sscString += "#6P" + _wFemurSscv;
                    sscString += "#5P" + _wTibiaSscv;
                }
                if (_legIndex == 1)
                {
                    sscString += "#11P" + _wCoxaSscv;
                    sscString += "#10P" + _wFemurSscv;
                    sscString += "#9P" + _wTibiaSscv;
                }
                if (_legIndex == 2)
                {
                    sscString += "#15P" + _wCoxaSscv;
                    sscString += "#14P" + _wFemurSscv;
                    sscString += "#13P" + _wTibiaSscv;
                }
            }
            else
            {
                _wCoxaSscv = (int)Math.round(((_coxaAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst));
                _wFemurSscv = (int)Math.round((((_femurAngle1[_legIndex] + 900)*1000/CPwmDiv + CPfConst)));
                _wTibiaSscv = (int)Math.round(((_tibiaAngle1[_legIndex] + 900)*1000/1059 + CPfConst));

                if (_legIndex == 5)
                {
                    sscString += "#23P" + _wCoxaSscv;
                    sscString += "#22P" + _wFemurSscv;
                    sscString += "#21P" + _wTibiaSscv;
                }
                if (_legIndex == 4)
                {
                    sscString += "#27P" + _wCoxaSscv;
                    sscString += "#26P" + _wFemurSscv;
                    sscString += "#25P" + _wTibiaSscv;
                }
                if (_legIndex == 3)
                {
                    sscString += "#31P" + _wCoxaSscv;
                    sscString += "#30P" + _wFemurSscv;
                    sscString += "#29P" + _wTibiaSscv;
                }
            }
        }

        sscString += "T" + (_nomGaitSpeed);

        Send(sscString);
    }

}


