﻿#include <Wire.h>
#include <FreeIMU1.h>

#define ECHOPIN 3                            // Pin to receive echo pulse
#define TRIGPIN 2

FreeIMU1 my3IMU = FreeIMU1();

float ypr[3];

int CenterDistanceLimit = 32;
int SideDistanceLimit = 440;

int TravelZ;
int TravelX;
int Rotate;
int Gait;
int Height;
int LegLiftHeight;
int BalanceMode;
int Disabled;

int Center;
int Left;
int Right;

int LeftTurns;
int RightTurns;

int Pitch;
int Roll;

int TurnDirection;

int doSomethingFun = 0;

int MaxSpeed = 80;

void setup()
{
  randomSeed(analogRead(0));

  TurnDirection = random(1);

  Wire.begin();

  Serial.begin(115200);
  Serial1.begin(38400);

  pinMode(ECHOPIN, INPUT); 	//sonar
  pinMode(TRIGPIN, OUTPUT);	//sonar

  Gait = 1;
  TravelZ = 0;
  TravelX = 0;
  Rotate = 0;
  Height = 0;
  LegLiftHeight = 15;
  BalanceMode = 0;
  Disabled = 0;

  LeftTurns = 0;
  RightTurns = 0;

  Pitch = 0;
  Roll = 0;

  delay(5);
  my3IMU.init(true); 				// the parameter enable or disable fast mode for gyroscope
  delay(5);		

  my3IMU.zeroGyro();
  my3IMU.initGyros();
}

void loop()
{

  my3IMU.getYawPitchRoll(ypr);

  Center = Ping();

  Left = map(analogRead(2), 1, 1024, 512, 0);
  Right = map(analogRead(3), 1, 1024, 512, 10);

  Serial.println("Distance/YPR - Center :" + String(Center) + " Left :" + String(Left) + " Right :" + String(Right) + " / " + String(int(ypr[0])) + "|" + String(int(ypr[1])) + "|" + String(int(ypr[2])) );


  Pitch = map(ypr[1], -5, 5, -30, 30);
  Roll = map(ypr[2], -5, 5, -30, 30);

  TravelZ = map(Center, 1, 100, 5, 50);

  if (LeftTurns > 1 && RightTurns > 1)
  {
    Serial.println("Seem to be stuck...");

    TravelZ = 10;
    TravelX = 0;
    Rotate = 0;

    if (TurnDirection = 1)
      Rotate = 2;
    else
      Rotate = -2;

    Serial1.println("~" + String(Gait) + "|" + String(TravelZ) + "|" + String(TravelX) + "|" + String(Rotate) + "|" + String(Height) + "|" + String(LegLiftHeight) + "|" + String(BalanceMode) + "|" + String(Disabled) + "|" + String(Pitch) + "|" + String(Roll) + "!");

    delay(800);

    LeftTurns = 0;
    RightTurns = 0;

    Rotate = 0;
  }
  else if (Center > CenterDistanceLimit && Left > SideDistanceLimit && Right > SideDistanceLimit)
  {
    TravelX = 0;
    Rotate = 0;

    LeftTurns = 0;
    RightTurns = 0;
  }
  else if (Center > CenterDistanceLimit && Left > SideDistanceLimit)
  {
    Serial.println("Turn left");

    TravelX = 10;
    Rotate = 1;

    LeftTurns = 0;
    RightTurns = 0;
  }
  else if (Center > CenterDistanceLimit && Right > SideDistanceLimit)
  {
    Serial.println("Turn right");

    TravelX = -10;
    Rotate = -1;

    LeftTurns = 0;
    RightTurns = 0;
  }
  else if (Left > SideDistanceLimit)
  {
    Serial.println("Turn hard left");

    TravelX = 20;
    Rotate = 2;
    LeftTurns++;
  }
  else if (Right > SideDistanceLimit)
  {
    Serial.println("Turn hard right");

    TravelX = -20;
    Rotate = -2;
    RightTurns++;
  }
  else
  {
    Serial.println("Reverse");

    TravelZ = 40;
    TravelX = 0;
    Rotate = 0;

    Serial1.println("~" + String(Gait) + "|" + String(TravelZ) + "|" + String(TravelX) + "|" + String(Rotate) + "|" + String(Height) + "|" + String(LegLiftHeight) + "|" + String(BalanceMode) + "|" + String(Disabled) + "|" + String(Pitch) + "|" + String(Roll) + "!");

    delay(1400);

    TravelZ = 10;

    if (TurnDirection = 1)
      Rotate = 1;
    else
      Rotate = -1;

    Serial1.println("~" + String(Gait) + "|" + String(TravelZ) + "|" + String(TravelX) + "|" + String(Rotate) + "|" + String(Height) + "|" + String(LegLiftHeight) + "|" + String(BalanceMode) + "|" + String(Disabled) + "|" + String(Pitch) + "|" + String(Roll) + "!");

    delay(1200);

    Rotate = 0;
  }

  Serial1.println("~" + String(Gait) + "|" + String(-TravelZ) + "|" + String(TravelX) + "|" + String(Rotate) + "|" + String(Height) + "|" + String(LegLiftHeight) + "|" + String(BalanceMode) + "|" + String(Disabled) + "|" + String(Pitch) + "|" + String(Roll) + "!");

  Serial.println("~" + String(Gait) + "|" + String(-TravelZ) + "|" + String(TravelX) + "|" + String(Rotate) + "|" + String(Height) + "|" + String(LegLiftHeight) + "|" + String(BalanceMode) + "|" + String(Disabled) + "|" + String(Pitch) + "|" + String(Roll) + "!");

  TurnDirection = random(1);

  delay(20);
}

int Ping()
{
  digitalWrite(TRIGPIN, LOW);                           		// Set the trigger pin to low for 2uS
  delayMicroseconds(2);
  digitalWrite(TRIGPIN, HIGH);                          		// Send a 10uS high to trigger ranging
  delayMicroseconds(10);
  digitalWrite(TRIGPIN, LOW);                     		// Send pin low again

  return (pulseIn(ECHOPIN, HIGH) / 58); //divide by 148 gives you inches, 58 gives you cm
}