﻿#include <Wire.h>
#include <FreeIMU1.h>

FreeIMU1 my3IMU = FreeIMU1();

float ypr[3];

void setup()
{

  Wire.begin();

  Serial.begin(115200);
  Serial2.begin(38400);

  pinMode(13, INPUT); 	//sonar echo Center
  pinMode(12, OUTPUT);	//sonar trig
  
  pinMode(5, INPUT); 	//sonar Left
  pinMode(4, OUTPUT);	//sonar

  pinMode(7, INPUT); 	//sonar Right
  pinMode(6, OUTPUT);	//sonar

  pinMode(3, INPUT); 	//sonar Far Right
  pinMode(2, OUTPUT);	//sonar

  pinMode(11, INPUT); 	//sonar Far Left
  pinMode(10, OUTPUT);	//sonar

  pinMode(9, INPUT); 	//sonar Rear Left
  pinMode(8, OUTPUT);	//sonar

  pinMode(19, INPUT); 	//sonar Rear Right
  pinMode(18, OUTPUT);	//sonar

  pinMode(15, INPUT); 	//sonar Rear
  pinMode(14, OUTPUT);	//sonar

  delay(5);
  my3IMU.init(false); 				// the parameter enable or disable fast mode for gyroscope
  delay(5);

  my3IMU.zeroGyro();

  my3IMU.getYawPitchRoll(ypr);
}

int Left = 0;
int Right = 0;
int Center = 0;

int FarLeft = 0;
int FarRight = 0;

int RearLeft = 0;
int RearRight = 0;
int Rear = 0;

void loop()
{
  Update();
    
  delay(40);
  Left = Ping(4, 5, 74);
  Update();
  //my3IMU.getYawPitchRoll(ypr);

  delay(40);
  FarRight = Ping(2, 3, 74);
  Update();
  my3IMU.getYawPitchRoll(ypr);

  delay(40);
  Center = Ping(12, 13, 74); //74 = give me the inches!
  Update();
  //my3IMU.getYawPitchRoll(ypr);

  delay(40);
  Right = Ping(6, 7, 74);
  Update();
  my3IMU.getYawPitchRoll(ypr);

  delay(40);
  FarLeft = Ping(10, 11, 74);
  Update();
  //my3IMU.getYawPitchRoll(ypr);

  delay(40);
  RearLeft = Ping(8, 9, 74);
  Update();
  my3IMU.getYawPitchRoll(ypr);

  delay(40);
  RearRight = Ping(18, 19, 74);
  Update();
  //my3IMU.getYawPitchRoll(ypr);

  delay(40);
  Rear = Ping(14, 15, 74);
  Update();
  my3IMU.getYawPitchRoll(ypr);

  Serial.println(String(Center) + ":" + String(Left) + ":" + String(Right) + ":"+ String(FarLeft) + ":"+ String(FarRight) + ":"+ String(RearLeft) +":"+ String(RearRight) +":"+ String(Rear) +":" + String(ypr[0]) + ":" + String(ypr[1]) + ":" + String(ypr[2]) );
}

void Update()
{
  Serial2.println(String(Center) + ":" + String(Left) + ":" + String(Right) + ":"+ String(FarLeft) + ":"+ String(FarRight) + ":"+ String(RearLeft) +":"+ String(RearRight) +":"+ String(Rear) +":" + String(ypr[0]) + ":" + String(ypr[1]) + ":" + String(ypr[2]) );
}

int Ping(int trigPin, int echoPin, int div)
{
  digitalWrite(trigPin, LOW);                           		// Set the trigger pin to low for 2uS
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);                          		// Send a 10uS high to trigger ranging
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);                     		// Send pin low again

  return (pulseIn(echoPin, HIGH, 29000) / div / 2); 
}